// JavaScript Document
$(document).ready(function(){
  $('.collapsible').collapsible({
      accordion : false // A setting that changes the collapsible behavior to expandable instead of the default accordion style
  });
  /* Login Logo Change */
  $('body').on('change', '#applicationLogo', function() {
    $("#LogoForm").ajaxForm({
      target: '#timelineProfilePic',
      beforeSubmit: function() {},
      success: function() {
        console.log("Oldu");
      },
      error: function() {

      }
    }).submit();
  });
  
  // Header Logo Change
  $('body').on('change', '#applicationLogoHeader', function() {
    $("#HeaderLogoForm").ajaxForm({
      target: '#timelineProfilePic',
      beforeSubmit: function() {},
      success: function() {
        console.log("Oldu");
      },
      error: function() {

      }
    }).submit();
  });
  Materialize.updateTextFields();
  var $SC_Ok = $('<span>Name Changed Successfully!</span>');
  var $SC_No = $('<span>Something went wron. Please try again later!</span>');
  //Change Script Name
  $("body").on("click","#changeSName",function() {
    var updateval = $(".scnameText").val();
    var dataString = 'applicationName=' + updateval;
    if ($.trim(updateval).length == 0) {
      Materialize.toast($SC_No, 5000); 
    } else {
      $.ajax({
        type: "POST",
        url: "admin/requests/changescriptname.php",
        data: dataString,
        cache: false,
        success: function(html) {
         Materialize.toast($SC_Ok, 5000); 
        }
      });
    }
    return false;
  });
  //Change Script Description
  $("body").on("click","#changeSDesc",function() {
    var updateval = $(".applicationDesc").val();
    var dataString = 'applicationDesc=' + updateval;
    if ($.trim(updateval).length == 0) {
      Materialize.toast($SC_No, 5000); 
    } else {
      $.ajax({
        type: "POST",
        url: "admin/requests/changescriptdesc.php",
        data: dataString,
        cache: false,
        success: function(html) {
         Materialize.toast($SC_Ok, 5000); 
        }
      });
    }
    return false;
  });
  // Insert Slider  
  $("body").on("click",".insertSlide", function(){

     var data = new FormData();
     data.append('slideDesc',$(".slideDesc").val());
     data.append('slideTitle',$(".slideTitle").val());
     var Image = $("#slideImage").prop("files")[0];;
     data.append('slideImage',Image);
     $.ajax({
        type: "POST",
        url:"/insertSlide.php",
        data: data,
        cache:false,
        processData:false,
        contentType:false,
		beforeSend: function(){
		$('#slid').append('<div class="preloader-wrapper small active" id="sld"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
		},
        success: function(html){
		  $('#sld').remove();
		  $("#ListSlid").prepend(html);
		  $('#SlideForm').trigger("reset");   
        } 
     });

  });
  //Delete Slide
  $("body").on("click",".deleteSlideItem",function(){
	 var ID = $(this).attr("id");
	 var data = 'sliderId=' + ID; 
	 $.ajax({
	   type: "POST",
	   url:"/admin/requests/deleteSlide",
	   data: data,
	   beforeSend: function(){
	   // Do Something
	   },
	   success: function(){
		$("#iD" + ID).fadeOut(300, function() {
          $("#iD" + ID).remove();
        });   
	   }	 
	 });
   });
  // Infinite Scroll User
  var scrollLoad = true;
   $(window).scroll(function() {
      if (scrollLoad && $(window).scrollTop() >= $(document).height() - $(window).height() - 300) {
         scrollLoad = false;
         var ID = $('#Users').children().last().attr('pKey-data');
         var newcontent = '<div class="postBody"><div class="glbD0w">No more user will be shown</div></div>';
         var dataString = "lastUid=" + ID;
         if (ID) {
            $.ajax({
               type: "POST",
               url: '/admin/requests/moreUser',
               data: dataString,
               cache: false,
               beforeSend: function() {
                  //$("#more" + ID).html('<img src="mat_icons/ajaxloader.gif" />');
               },
               success: function(html) {
                  if (html) {
                     $("#Users").append(html);
                     scrollLoad = true;
                  } else {
                     $('#Users').append(newcontent);
                  }

               }
            });
         } else {
            $("#more").html('The End');
         }
         return false;
      }
   });
   // Call user info Details
   $("body").on("click", ".UeAd", function() {
      //doing AJAX request
	  var ID  = $(this).attr('id');
      $(".settingsWrap").addClass("opInf");
      $.ajax({
		 type: 'GET',
         url: "/admin/requests/editUser?euid=" + ID,
         beforeSend: function() {
            $('#myDiv').fadeOut('slow');
         },
         success: function(response) {
            $('#useriDet').html(response);
            $('select').material_select();
            setTimeout(function() {
               $('.settingsInformation').removeClass('infOpAn');
            }, 1000);
         }
      });
   });
   // Close user info Details
   $("body").on("click", ".EclpW", function() {
      setTimeout(function() {
         $(".settingsWrap").removeClass("opInf");
      }, 850);
      $(".settingsInformation").addClass("closeAn");
      setTimeout(function() {
         $.ajax({
            url: "/admin/requests/editUser",
            beforeSend: function() {
               $('#myDiv').fadeOut('slow');
            },
            success: function(response) {
               $('.settingsInformation').remove();
            }
         });
      }, 1000);
   });
   // Edit Facebook
   $("body").on("click", "#efb", function() {
      var fbNm = $("input[name='efb']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'efb=' + fbNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#fbh').addClass('disH');
            $('#fb').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#fbh').removeClass('disH');
         }
      });
   });
   // Edit Twitter
   $("body").on("click", "#etw", function() {
      var twNm = $("input[name='etw']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'etw=' + twNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#twk').addClass('disH');
            $('#tw').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#twk').removeClass('disH');
         }
      });
   });
   //Edit Google Plus
   $("body").on("click", "#egp", function() {
      var gpNm = $("input[name='egp']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'egp=' + gpNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#gpk').addClass('disH');
            $('#gp').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#gpk').removeClass('disH');
         }
      });
   });
   // Edit Youtube
   $("body").on("click", "#eyt", function() {
      var ytNm = $("input[name='eyt']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'eyt=' + ytNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#ytk').addClass('disH');
            $('#yt').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#ytk').removeClass('disH');
         }
      });
   });
   // Edit Instagram
   $("body").on("click", "#ein", function() {
      var inNm = $("input[name='ein']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'ein=' + inNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#ink').addClass('disH');
            $('#in').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#ink').removeClass('disH');
         }
      });
   });
   // Edit Website
   $("body").on("click", "#ewb", function() {
      var wbNm = $("input[name='ewb']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'ewb=' + wbNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#wbk').addClass('disH');
            $('#wb').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#wbk').removeClass('disH');
         }
      });
   });
   // Change UserFullName
   $("body").on("click", "#esunm", function() {
      var UNm = $("input[name='eusername']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'eusername=' + UNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#Uk').addClass('disH');
            $('#sunm').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
           $('#loH').remove();
           $('#Uk').removeClass('disH');
         }
      });
   });
   // Change Bio
   $("body").on("click", "#esendobio", function() {
      var bimm = $("textarea[name='ebiog']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'ebio=' + bimm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#bUk').addClass('disH');
            $('#bioL').append('<div class="preloader-wrapper small active" id="loHB"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loHB').remove();
            $('#bUk').removeClass('disH');
         }
      });
   });
   // Edit Telephone
   $("body").on("click", "#etel", function() {
      var telNm = $("input[name='etel']").val();
	  var ID = $(this).attr('data-uid');
      var data = 'etel=' + telNm + '&euid=' + ID;
      $.ajax({
         url: '/admin/requests/editDetail',
         type: 'POST',
         data: data,
         beforeSend: function() {
            $('#telk').addClass('disH');
            $('#tel').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function(html) {
            $('#loH').remove();
            $('#telk').removeClass('disH');
         }
      });
   });
   // Edit Location
   $("body").on("change", "#elocation", function() {
      var loc = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'eloc=' + loc + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#loc').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Edit Gender
   $("body").on("change", "#egend", function() {
      var gend = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'egend=' + gend + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#gendr').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Post Privacy
   $("body").on("click", ".ephd", function() {
      var phd = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'epst=' + phd + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#pst').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Follower Privacy
   $("body").on("click", ".eflwr", function() {
      var flwor = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'eflwr=' + flwor + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#flwry').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Following Privacy
   $("body").on("click", ".eflw", function() {
      var flw = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'eflw=' + flw + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#flwg').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Social Account Privacy
   $("body").on("click", ".ehsoc", function() {
      var scs = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'eslca=' + scs + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#scA').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Phone Privacy
   $("body").on("click", ".ephn", function() {
      var phn = $(this).attr('value');
	  var ID = $(this).attr('data-uid');
      var data = 'ephn=' + phn + '&euid=' + ID;
      $.ajax({
         type: 'POST',
         url: '/admin/requests/editDetail',
         data: data,
         beforeSend: function() {
            $('#PhN').append('<div class="preloader-wrapper small active" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
         },
         success: function() {
            $('#loH').remove();
         }
      });
   });
   // Delete Reported Post
   $("body").on("click",".delr",function(){
	  var ID = $(this).attr("id");  
	  var R_ID = $(this).attr("data-msgID"); 
	  var data = 'rid=' + ID;
	  $.ajax({
		type: 'POST',
		url:'/admin/requests/deleteReport',
		data:data,
		beforeSend: function(){
		$('#reporID' + R_ID).append('<div class="preloader-wrapper small active psAb" id="loH"><div class="spinner-layer spinner-green-only"><div class="circle-clipper left"><div class="circle"></div></div><div class="gap-patch"><div class="circle"></div></div><div class="circle-clipper right"><div class="circle"></div></div></div></div>');
		},
		success:function(){
		  $("#reporID" + R_ID).fadeOut("slow");
	    }  
	  });
   });
});
